#pragma once

#include <utils.h>
#include "BaseRenderable.h"
#include "Entity3d.h"
#include "Vector3d.h"

#define MAX_ENTITIES 500

class Renderable3d : public BaseRenderable
{
public:
	Renderable3d(int typeID);
	~Renderable3d(void);

	//virtual void SaveToXml(TiXmlElement *currentElement);
	//virtual void LoadFromXml(TiXmlElement *currentElement);

	virtual void Initialize();
	virtual void Render();
	virtual void Update();

protected:
	virtual void BuildCollection() = 0;

	Entity3d m_entityCollection[MAX_ENTITIES];
	int m_entityCollectionCount;
};